Package org.eclipse.debug.core.model

# Interface IDebugElement

All Superinterfaces:
  `IAdaptable`

All Known Subinterfaces:
  `IDebugTarget`, `IErrorReportingExpression`, `IExpression`, `IIndexedValue`, `IMemoryBlock`, `IMemoryBlockExtension`, `IRegister`, `IRegisterGroup`, `IStackFrame`, `IThread`, `IValue`, `IVariable`, `IWatchExpression`

All Known Implementing Classes:
  `DebugElement`

public interface IDebugElement extends IAdaptable
A debug element represents an artifact in a program being debugged.

Some methods on debug elements require communication with the target program. Such methods may throw a `DebugException` with a status code of `TARGET_REQUEST_FAILED` when unable to complete a request due to a failure on the target. Methods that require communication with the target program or require the target to be in a specific state (for example, suspended), are declared as such.

Debug elements are language independent. However, language specific features can be made available via the adapter mechanism provided by `IAdaptable`, or by extending the debug element interfaces. A debug model is responsible for declaring any special adapters its debug elements implement.

Clients may implement this interface.

## Method Summary

Modifier and Type
Method
Description
`IDebugTarget`
`getDebugTarget()`
Returns the debug target this element is contained in.
`ILaunch`
`getLaunch()`
Returns the launch this element is contained in.
`String`
`getModelIdentifier()`
Returns the unique identifier of the plug-in this debug element originated from.

### Methods inherited from interface org.eclipse.core.runtime.IAdaptable

`getAdapter`

## Method Details

### getModelIdentifier

String getModelIdentifier()
Returns the unique identifier of the plug-in this debug element originated from.

Returns:
  the plug-in identifier

### getDebugTarget

IDebugTarget getDebugTarget()
Returns the debug target this element is contained in.

Returns:
  the debug target this element is contained in

### getLaunch

ILaunch getLaunch()
Returns the launch this element is contained in.

Returns:
  the launch this element is contained in